/*
 * (C) Copyright 2005
 * Detlef Vollmann, Toradex AG, <dv@vollmann.ch>
 *
 * (C) Copyright 2004
 * Robert Whaley, Applied Data Systems, Inc. rwhaley@applieddata.net
 *
 * (C) Copyright 2002
 * Kyle Harris, Nexus Technologies, Inc. kharris@nexus-tech.net
 *
 * (C) Copyright 2002
 * Sysgo Real-Time Solutions, GmbH <www.elinos.com>
 * Marius Groeger <mgroeger@sysgo.de>
 *
 * Configuation settings for the VPAC270 module
 *
 * See file CREDITS for list of people who contributed to this
 * project.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 */

#ifndef __CONFIG_H
#define __CONFIG_H

//#define DEBUG 15
//#define CONFIG_TIMESTAMP
/*
 * If we are developing, we might want to start armboot from ram
 * so we MUST NOT initialize critical regs like mem-timing ...
 */
#define CONFIG_INIT_CRITICAL		/* undef for developing */

/*
 * High Level Configuration Options
 * (easy to change)
 */
#define CONFIG_PXA27X		1	/* This is an PXA27x CPU    */
#define CONFIG_VPAC270		1	/* on a Colibri module     */
//#define BOARD_LATE_INIT		1

#undef CONFIG_USE_IRQ			/* we don't need IRQ/FIQ stuff */

/*
 * Size of malloc() pool
 */
//#define CFG_MALLOC_LEN	    (CFG_ENV_SECT_SIZE + 128*1024)
#define CFG_MALLOC_LEN		0
#define CFG_GBL_DATA_SIZE	128	/* size in bytes reserved for initial data */

/*
 * Hardware drivers
 */

/*
 * select serial console configuration
 */
#define CONFIG_FFUART	       1       /* we use FFUART on Colibri */

/* allow to overwrite serial and ethaddr */
#define CONFIG_ENV_OVERWRITE

#define CONFIG_BAUDRATE	       38400
						/* valid baudrates */
#define CFG_BAUDRATE_TABLE	{ 9600, 19200, 38400, 57600, 115200, 230400 }

//#define CONFIG_COMMANDS		(CFG_CMD_MEMORY|CFG_CMD_FLASH|CFG_CMD_ENV|CFG_CMD_NET|CFG_CMD_LOADB)
#define CONFIG_COMMANDS		(CFG_CMD_MEMORY|CFG_CMD_FLASH|CFG_CMD_ENV|CFG_CMD_NET|CFG_CMD_LOADB|CFG_CMD_PING|CFG_CMD_SDRAM|CFG_CMD_DIAG)
#define CONFIG_MTEST
//#define CONFIG_COMMANDS		(CONFIG_CMD_DFL | CFG_CMD_DIAG | CFG_CMD_DHCP | CFG_CMD_SDRAM)
/* #define CONFIG_COMMANDS		(CONFIG_CMD_DFL | CFG_CMD_DIAG | CFG_CMD_DHCP | CFG_CMD_SDRAM | CFG_CMD_KGDB) */
/*#define CONFIG_COMMANDS		(CONFIG_CMD_DFL | CFG_CMD_DIAG | CFG_CMD_SDRAM)*/

/* this must be included AFTER the definition of CONFIG_COMMANDS (if any) */
#include <cmd_confdefs.h>

#undef CONFIG_SHOW_BOOT_PROGRESS

//#define CONFIG_ETHADDR          08:00:3e:26:0a:5b
#define CONFIG_ETHADDR          00:01:02:03:04:05
#define CONFIG_NETMASK          255.255.255.0
#define CONFIG_IPADDR           192.168.1.99
#define CONFIG_SERVERIP         192.168.1.3

#define CONFIG_BOOTDELAY        3
#define CONFIG_BOOTCOMMAND      "FIXME"
#define CONFIG_BOOTARGS         "root=/dev/mtdblock2 rootfstype=jffs2 console=ttyS0,38400"
#define CONFIG_CMDLINE_TAG              1       /* enable passing of ATAGs */
#define CONFIG_SETUP_MEMORY_TAGS        1
/* #define CONFIG_INITRD_TAG	 1 */
/*#define CONFIG_SERIAL_TAG               1*/   /* we transfer the ethernet addr this way */

#if (CONFIG_COMMANDS & CFG_CMD_KGDB)
#define CONFIG_KGDB_BAUDRATE	230400		/* speed to run kgdb serial port */
#define CONFIG_KGDB_SER_INDEX	2		/* which serial port to use */
#endif

/*
 * Miscellaneous configurable options
 */

#define CFG_LONGHELP				/* undef to save memory		*/
#define CFG_PROMPT		"u-boot> "		/* Monitor Command Prompt */
#define CFG_CBSIZE		256		/* Console I/O Buffer Size	*/
#define CFG_PBSIZE (CFG_CBSIZE+sizeof(CFG_PROMPT)+16) /* Print Buffer Size */
#define CFG_MAXARGS		16		/* max number of command args	*/
#define CFG_BARGSIZE		CFG_CBSIZE	/* Boot Argument Buffer Size	*/
#define CFG_DEVICE_NULLDEV	1

#define CFG_MEMTEST_START	0xa0400000	/* memtest works on	*/
#define CFG_MEMTEST_END		0xa0800000	/* 4 ... 8 MB in DRAM	*/

#undef	CFG_CLKS_IN_HZ		/* everything, incl board info, in Hz */

#define CFG_LOAD_ADDR		0xa1000000	/* default load address */

#define CFG_HZ			3686400		/* incrementer freq: 3.6864 MHz */
/*#define CFG_CPUSPEED		0x207		 need to look more closely, I think this is Turbo = 2x, L=91Mhz */
#define CFG_CPUSPEED		0x190		 /* standard setting for 312MHz; L=16, N=1.5, A=0, SDCLK!=SystemBus */

/*
 * Stack sizes
 *
 * The stack sizes are set up in start.S using the settings below
 */
#define CONFIG_STACKSIZE	(64*1024)	/* regular stack */
#ifdef CONFIG_USE_IRQ
#define CONFIG_STACKSIZE_IRQ	(4*1024)	/* IRQ stack */
#define CONFIG_STACKSIZE_FIQ	(4*1024)	/* FIQ stack */
#endif

/*
 * Physical Memory Map
 */
#define CONFIG_NR_DRAM_BANKS	2	   /* we have 1 bank of DRAM, but we have room for 4 */
#define PHYS_SDRAM_1		0xa0000000 /* SDRAM Bank #1 */
//#define PHYS_SDRAM_1_SIZE	0x02000000 /* 32 MB */
#define PHYS_SDRAM_2		0x80000000 /* SDRAM Bank #2 */
//#define PHYS_SDRAM_2_SIZE	0x00000000 /* 0 MB */
//#define PHYS_SDRAM_3		0xc0000000 /* SDRAM Bank #3 */
//#define PHYS_SDRAM_3_SIZE	0x00000000 /* 0 MB */
//#define PHYS_SDRAM_4		0xd0000000 /* SDRAM Bank #4 */
//#define PHYS_SDRAM_4_SIZE	0x00000000 /* 0 MB */

#define CFG_DRAM_BASE		PHYS_SDRAM_1
//#define CFG_DRAM_SIZE		PHYS_SDRAM_1_SIZE

#define PHYS_FLASH_1            0x00000000 /* Flash Bank #1 */
#define PHYS_FLASH_2            0x00000000 /* Flash Bank #2 not used, but used in code */
#define PHYS_FLASH_SIZE         0x02000000 /* 32 MB */
#define PHYS_FLASH_BANK_SIZE    0x02000000 /* 32 MB Banks */
//#define PHYS_FLASH_SECT_SIZE    0x00020000 /* 128 KB sectors (x2) */

#define CFG_FLASH_BASE		PHYS_FLASH_1

/*
 * FLASH and environment organization
 */
#define CFG_MAX_FLASH_BANKS     1    /* max number of memory banks           */
#define CFG_MAX_FLASH_SECT      256  /* max number of sectors on one chip    */

/* timeout values are in ticks */
#define CFG_FLASH_ERASE_TOUT    (100*CFG_HZ) /* Timeout for Flash Erase */
#define CFG_FLASH_WRITE_TOUT    (100*CFG_HZ) /* Timeout for Flash Write */

/* FIXME */
#define CFG_ENV_IS_IN_FLASH 1
//#define CFG_FIX_PARAM_SIZE 256
#define CFG_ENV_ADDR        (PHYS_FLASH_1 + 0x18000)/* Addr of Environment Sector   */
#define CFG_ENV_SIZE        (2*1024)
#define CFG_ENV_SECT_SIZE	0x8000

/*#define CFG_DEEP_DEBUG  1*/

/*
 * Davicom DM9000 Network Card
 */
#define CONFIG_DRIVER_DM9000            1
#define CONFIG_DM9000_BASE              0x08000300 /* CS2         */
#define CONFIG_DM9000_USE_32BIT         1
//#define CONFIG_DM9000_USE_16BIT         1
#define CONFIG_ETH_ADDR_IN_ENV          1
#undef  CONFIG_SHOW_ACTIVITY
#define CONFIG_NET_RETRY_COUNT          10         /* # of retries          */


/*
 * GPIO settings
 */
#if 0       /* minimal vpac270 settings, includes FFUART and Ethernet */
#define CFG_GPSR3_VAL   0x00000000
#define CFG_GPSR2_VAL   0x0000c000	// GPIO78, GPIO79
#define CFG_GPSR1_VAL   0x00020000	// GPIO49
#define CFG_GPSR0_VAL   0x00000000

#define CFG_GPCR3_VAL	0x0
#define CFG_GPCR2_VAL	0x0
#define CFG_GPCR1_VAL	0x0
#define CFG_GPCR0_VAL	0x0

#define CFG_GPDR3_VAL   0x00000000
#define CFG_GPDR2_VAL   0x0000c000	// GPIO78, GPIO79
#define CFG_GPDR1_VAL   0x00020180	// GPIO39, GPIO40, GPIO49
#define CFG_GPDR0_VAL   0x08000000	// GPIO27

#define CFG_GAFR3_U_VAL 0x00000000
#define CFG_GAFR3_L_VAL 0x00000300	// GPIO100=FFCTS
#define CFG_GAFR2_U_VAL 0x00000000
#define CFG_GAFR2_L_VAL 0xa0000000	// GPIO78=nCS2, GPIO79=nCS3
#define CFG_GAFR1_U_VAL 0x00000008	// GPIO49=nPWE
#define CFG_GAFR1_L_VAL 0x00029018	// GPIO33=FFDSR, GPIO34=FFRXD, GPIO38=FFRI, GPIO39=FFTXD, GPIO40=FFDTR
#define CFG_GAFR0_U_VAL 0x00c00010	// GPIO18=RDY, GPIO27=FFRTS
#define CFG_GAFR0_L_VAL 0x00100000	// GPIO10=FFDCD

#else       /* maximal vpac270 settings */
#define CFG_GPSR3_VAL   0x00000002	// GPIO97
#define CFG_GPSR2_VAL   0x8020c000	// GPIO78-79, GPIO85, GPIO95
#define CFG_GPSR1_VAL   0x00cf0000	// GPIO48-51, GPIO54-55
#define CFG_GPSR0_VAL   0x00000000

#define CFG_GPCR3_VAL	0x0
#define CFG_GPCR2_VAL	0x0
#define CFG_GPCR1_VAL	0x0
#define CFG_GPCR0_VAL	0x0

#define CFG_GPDR3_VAL   0x00000104	// GPIO98, GPIO104
#define CFG_GPDR2_VAL   0x8020ffff	// GPIO64-79, GPIO85, GPIO95
#define CFG_GPDR1_VAL   0xfccf2981	// GPIO32, GPIO39-40, GPIO43, GPIO45, GPIO48-51, GPIO54-55, GPIO58-63
#define CFG_GPDR0_VAL   0xc8318800	// GPIO11 GPIO15-16, GPIO20-21, GPIO27, GPIO30-31

#define CFG_GAFR3_U_VAL 0x00000001	// GPIO112=MMCMD
#define CFG_GAFR3_L_VAL 0x10010310	// GPIO98=AC97_SYSCLK, GPIO100=FFCTS, GPIO104=PSKTSEL, GPIO110=MMDAT2
#define CFG_GAFR2_U_VAL 0x41000400	// GPIO85=nPCE1, GPIO92=MMDAT0, GPIO95=AC97_RESET
#define CFG_GAFR2_L_VAL 0xaaaaaaaa	// GPIO64-73=LDD6-15, GPIO74=L_FCLK, GPIO75=L_LCLK,
					// GPIO76=L_PCLK, GPIO77=L_BIAS, GPIO78=nCS2, GPIO79=nCS3
#define CFG_GAFR1_U_VAL 0xaaa5a0aa	// GPIO48=nPOE, GPIO49=nPWE, GPIO50=nPIOR, GPIO51=nPIOW
					// GPIO54=nPCE2, GPIO55=nPREG, GPIO58-63=LDD0-5
#define CFG_GAFR1_L_VAL 0x0992901a	// GPIO32=MMCLK, GPIO33=FFDSR, GPIO34=FFRXD, GPIO38=FFRI, GPIO39=FFTXD
					// GPIO40=FFDTR, GPIO42=BTRXD, GPIO43=BTTXD, GPIO44=BTCTS, GPIO45=BTRTS
#define CFG_GAFR0_U_VAL 0xa5c00510	// GPIO18=RDY, GPIO20=SDCS2, GPIO21=SDCS3, GPIO27=FFRTS, GPIO28=AC97_BCLK
					// GPIO29=AC97_SDATA_IN0, GPIO30=AC97_SDATA_OUT, GPIO31=AC97_SYNC
#define CFG_GAFR0_L_VAL 0x00100000	// GPIO10=FFDCD

#endif


#define CFG_PSSR_VAL		0x30

/*
 * Clock settings
 */
#define CFG_CKEN		0x00500240 /* CKEN22_MEMC, CKEN20_SRAM, CKEN9_OSTM, CKEN6_FFUART */
#define CFG_CCCR		0x02000190 /*   312Mhz */
/*#define CFG_CCCR		0x02000290    520Mhz */
/* #define CFG_CCCR		0x02000210  416 Mhz */

/*
 * Memory settings
 */

#define CFG_MSC0_VAL		0x3ffc95f2
#define CFG_MSC1_VAL		0x02ccf974
#define CFG_MSC2_VAL		0x00000000
//#define CFG_MDCNFG_VAL		0x08000AA8	// k4s281633d = 9cols,12rows,4banks
//#define CFG_MDCNFG_VAL		0x08000AC8	// toradex dimm270 = 9cols,13rows,4banks
//#define CFG_MDCNFG_VAL		0x88000AD0	// k4s511633f = 10cols,13rows,4banks
//#define CFG_MDCNFG_VAL		0x88000AD8	// k4s511633f = 11cols,13rows,4banks
#define CFG_MDREFR_VAL		0x0000001E
#define CFG_MDMRS_VAL		0x00000000

#define CFG_FLYCNFG_VAL		0x00010001
#define CFG_SXCNFG_VAL		0x40044004

#define CFG_MEM_BUF_IMP     0x0f   /* factory default for PXA is 5 */

/*
 * PCMCIA and CF Interfaces
 */
#define CFG_MECR_VAL		0x00000001
#define CFG_MCMEM0_VAL		0x00014307
#define CFG_MCMEM1_VAL		0x00014307
#define CFG_MCATT0_VAL		0x0001C787
#define CFG_MCATT1_VAL		0x0001C787
#define CFG_MCIO0_VAL		0x0001430F
#define CFG_MCIO1_VAL		0x0001430F


#endif	/* __CONFIG_H */
